﻿Imports System.Drawing.Imaging

Public Class frmSave

    Private imgType As ImageFormat

    Private Sub ReplaceChars(ByVal txtBox As TextBox)
        Dim s_Old As Integer = txtBox.SelectionStart
        txtBox.Text = Replace(txtBox.Text, "\", "")
        txtBox.Text = Replace(txtBox.Text, "/", "")
        txtBox.Text = Replace(txtBox.Text, ":", "")
        txtBox.Text = Replace(txtBox.Text, "*", "")
        txtBox.Text = Replace(txtBox.Text, "?", "")
        txtBox.Text = Replace(txtBox.Text, "<", "")
        txtBox.Text = Replace(txtBox.Text, ">", "")
        txtBox.Text = Replace(txtBox.Text, "|", "")
        txtBox.Text = Replace(txtBox.Text, """", "")
        txtBox.SelectionStart = s_Old
    End Sub

    Private Sub frmSave_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Add formats
        cboFormat.Items.Add("Bitmap")
        cboFormat.Items.Add("GIF")
        cboFormat.Items.Add("PNG")
        cboFormat.Items.Add("JPEG")
        cboFormat.SelectedIndex = 0
    End Sub

    Private Sub cmdOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOK.Click
        Dim bmp As Bitmap = Nothing
        Dim fName As String = vbNullString
        Dim fTitle As String = vbNullString
        Dim fExt As String = vbNullString

        Select Case cboFormat.SelectedIndex
            Case 0
                'Save bitmap
                fExt = ".bmp"
                imgType = ImageFormat.Bmp
            Case 1
                'Save gif
                fExt = ".gif"
                imgType = ImageFormat.Gif
            Case 2
                'Save png
                fExt = ".png"
                imgType = ImageFormat.Png
            Case 3
                'Save jpeg
                fExt = ".jpeg"
                imgType = ImageFormat.Jpeg
        End Select

        'Do image save here.
        Dim fd As New FrameDimension(TheImage.FrameDimensionsList(0))
        'Get number of frames.
        Dim fCount As Integer = TheImage.GetFrameCount(FrameDimension.Time)

        For counter As Integer = 0 To fCount - 1
            'Set the image to extract.
            TheImage.SelectActiveFrame(fd, counter)
            'Build file title.
            fTitle = txtName.Text
            'Replace $ with counter value.
            fTitle = Replace(fTitle, "$", counter.ToString())
            'Build extract image filename.
            fName = System.IO.Path.Combine(txtSave.Text, fTitle & fExt)
            'Create bitmap
            bmp = New Bitmap(TheImage)
            Try
                'Extract image and save.
                bmp.Save(fName, imgType)
            Catch ex As Exception

            End Try
        Next

        Dim p As New System.Diagnostics.Process

        If (chkOpenFolder.Checked) Then
            p.StartInfo.FileName = txtSave.Text
            Try
                p.Start()
            Catch ex As Exception

            End Try
        End If

        'Tidy up
        bmp = Nothing
        fd = Nothing
        fName = vbNullString
        fExt = vbNullString

        'Close form
        Close()
    End Sub

    Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click

        Close()
    End Sub

    Private Sub cmdOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOpen.Click
        Dim fb As New FolderBrowserDialog
        fb.Description = "Save To:"
        fb.SelectedPath = txtSave.Text

        If (fb.ShowDialog() = DialogResult.OK) Then
            'Update text box.
            txtSave.Text = fb.SelectedPath
        End If

        fb = Nothing
    End Sub

    Private Sub txtSave_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSave.TextChanged
        cmdOK.Enabled = (txtSave.Text.Length > 0) AndAlso (txtName.Text.Length > 0)
    End Sub

    Private Sub txtName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtName.TextChanged
        'Replace invaild chars.
        ReplaceChars(txtName)
        txtSave_TextChanged(sender, e)
    End Sub
End Class